import 'dart:convert';
import 'package:marianum_mobile/api/marianumcloud/webdav/queries/listFiles/listFiles.dart';
import 'package:marianum_mobile/api/marianumcloud/webdav/queries/listFiles/listFilesParams.dart';
import 'package:marianum_mobile/api/marianumcloud/webdav/queries/listFiles/listFilesResponse.dart';
import 'package:marianum_mobile/api/requestCache.dart';

class ListFilesCache extends RequestCache<ListFilesResponse> {
  String path;

  ListFilesCache({required onUpdate, required this.path}) : super(RequestCache.cacheNothing, onUpdate) {
    String cacheName = path.replaceAll(RegExp("[^A-Za-z0-9]"), "_"); //TODO this is very evil, "/ü/" > "___" also "/ä/" > "___"
    start("MarianumMobile", "wd-folder-$cacheName");
  }

  @override
  Future<ListFilesResponse> onLoad() async {
    ListFilesResponse data = await ListFiles(ListFilesParams(path)).run();
    return data;
  }

  @override
  ListFilesResponse onLocalData(String json) {
    return ListFilesResponse.fromJson(jsonDecode(json));
  }

}